VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsMail"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text


Private plPort As String
Private psHost As String


Private psPort As String

Private psTo As String
Private psToDisplay As String
Private psFrom As String
Private psFromDisplay As String

Private psFromReply As String
Private psReplyTo As String
Private psSubject As String
Private psMessage As String



Private pbExitImmediately As Boolean



Private Const SETTINGS_KEY = "Settings"








Public Property Get Subject() As String
    Subject = psSubject
End Property

Public Property Let Subject(ByVal NewValue As String)
psSubject = NewValue
End Property

Public Property Get From() As String
    From = psFrom
End Property


Public Property Let From(ByVal NewValue As String)
    If IsValidEmailAddress(NewValue) Then
        psFrom = NewValue
    Else
        psFrom = ""
    End If
    
End Property

Public Property Let FromDisplayName(ByVal NewValue As String)
    psFromDisplay = NewValue
    SaveSetting App.EXEName, SETTINGS_KEY, "FromDisplayName", NewValue
End Property
Public Property Get FromDisplayName() As String
    FromDisplayName = psFromDisplay
End Property
Public Property Get Recipient() As String
 Recipient = psTo
End Property

Public Property Let Recipient(ByVal NewValue As String)
    If IsValidEmailAddress(NewValue) Then
       psTo = NewValue
    
    Else
        psTo = ""
    End If
    
End Property
Public Property Get RecipientDisplayName() As String
    RecipientDisplayName = psToDisplay
End Property

Public Property Let RecipientDisplayName(ByVal NewValue As String)
    psToDisplay = NewValue
End Property
Public Property Get Message() As String
    Message = psMessage
End Property

Public Property Let Message(ByVal NewValue As String)
    psMessage = NewValue
End Property

Public Property Get SMTPHost() As String
    SMTPHost = frmSckHost.sckMail.RemoteHost
End Property

Public Property Let SMTPHost(NewValue As String)
        If IsValidIPHost(NewValue) Then
            frmSckHost.sckMail.RemoteHost = NewValue
        Else
            frmSckHost.sckMail.RemoteHost = ""
        End If
End Property
Public Property Get SMTPPort() As Long
    SMTPPort = frmSckHost.sckMail.RemotePort
End Property

Public Property Let SMTPPort(ByVal NewValue As Long)
    If NewValue < 1 Or NewValue > 65535 Then
        frmSckHost.sckMail.RemotePort = 0
        
    Else
        frmSckHost.sckMail.RemotePort = NewValue
    End If
End Property

Private Sub Class_Initialize()
Dim sKey As String

sKey = App.EXEName

SMTPPort = CLng(GetSetting(sKey, SETTINGS_KEY, "RemotePort", "25"))
SMTPHost = GetSetting(sKey, SETTINGS_KEY, "RemoteHost", "")
FromDisplayName = GetSetting(sKey, SETTINGS_KEY, "FromDisplayName", "")
From = GetSetting(sKey, SETTINGS_KEY, "From", "")
'Set frmSckHost.EmailClient = Me




End Sub

Private Function IsValidIPHost(HostString As String) As Boolean

Dim sHost As String
Dim bDottedQuad As Boolean
Dim sSplit() As String
Dim iCtr As Integer
Dim bAns As Boolean
Dim sTopLevelDomains() As String

sHost = HostString

If InStr(sHost, ".") = 0 Then
    IsValidIPHost = False
    Exit Function
End If

Split sHost, sSplit, "."

If UBound(sSplit) = 3 Then
    bDottedQuad = True
    For iCtr = 0 To 3
        If Not IsNumeric(sSplit(iCtr)) Then
            bDottedQuad = False
            Exit For
        End If
    Next



    If bDottedQuad Then
        bAns = True
        For iCtr = 0 To 3
            If iCtr = 0 Then
            bAns = Val(sSplit(iCtr)) <= 239
                If bAns = False Then Exit For
            Else
                bAns = Val(sSplit(iCtr)) <= 255
                If bAns = False Then Exit For
            End If
        Next
        
        IsValidIPHost = bAns

        
        Exit Function
    End If
End If 'ubound(ssplit) = 3

    'NOTE: IF USING ON AN INTRANET MODIFY THE BELOW TO:
    'isvalidiphost = true
    'OR do whatever cheking you need to do on the SMPT host (shost)
    
    IsValidIPHost = True





End Function





Public Property Get ReplyToAddress() As String
    ReplyToAddress = psReplyTo
End Property

Public Property Let ReplyToAddress(ByVal NewValue As String)
        psReplyTo = "<" & NewValue & ">"
End Property
Public Sub Send()
Dim sMsg As String
Dim sSenderName As String
Dim sRecipientName As String

    'if there's already an error, we won't bother to try sending
If psTo = "" Or psFrom = "" Then
    SendFail
Else
    'RaiseEvent Status("Connecting to Server...")
    ResetGlobals
    pbExitImmediately = False
    With frmSckHost.sckMail
        If .State <> sckConnected Then
            .Connect
            WaitUntilTrue gbConnectOK, 20
            If pbExitImmediately Then Exit Sub
            
      End If
            If Not gbConnectOK Then
                TimeOut
                Exit Sub
            End If
            gbRequestAccepted = False
            .SendData "HELO " & Mid$(psFrom, InStr(psFrom, "@") + 1) & vbCrLf
            WaitUntilTrue gbRequestAccepted, 20
            If pbExitImmediately Then Exit Sub
            
            If Not gbRequestAccepted Then
                TimeOut
                Exit Sub
            End If
            
            
            
            gbRequestAccepted = False
            'RaiseEvent Status("Sending Sender Information...")
            .SendData "MAIL FROM: <" & psFrom & ">" & vbCrLf
           
           WaitUntilTrue gbRequestAccepted, 20
             If pbExitImmediately Then Exit Sub
            If Not gbRequestAccepted Then
                TimeOut
                Exit Sub
            End If

         gbRequestAccepted = False
       ' RaiseEvent Status("Sending Recipient Information...")
         .SendData "RCPT TO: <" & psTo & ">" & vbCrLf
         
            WaitUntilTrue gbRequestAccepted, 20
             If pbExitImmediately Then Exit Sub
            If Not gbRequestAccepted Then
                TimeOut
                Exit Sub
            End If
            
            gbDataOK = False
            'RaiseEvent Status("Sending Message...")
            .SendData "DATA" & vbCrLf
            WaitUntilTrue gbDataOK, 20
             If pbExitImmediately Then Exit Sub
            If Not gbDataOK Then
                TimeOut
                Exit Sub
            End If
            
            
            gbRequestAccepted = False
            

            If Len(psFromDisplay) Then sSenderName = Chr$(34) & psFromDisplay & Chr(34)
            If Len(sSenderName) Then sSenderName = sSenderName & " "
            sSenderName = sSenderName & "<" & psFrom & ">"
            
             If Len(psToDisplay) Then sRecipientName = Chr$(34) & psToDisplay & Chr$(34)
            If Len(sRecipientName) Then sRecipientName = sRecipientName & " "
            sRecipientName = sRecipientName & "<" & psTo & ">"
            sMsg = "DATE: " & Format$(Now, "dd mmm yy ttttt") & vbCrLf
            
            sMsg = sMsg & "FROM: " & sSenderName & vbCrLf
            sMsg = sMsg & "TO: " & sRecipientName & vbCrLf
            If Len(psReplyTo) Then sMsg = sMsg & "Reply-to: " & psReplyTo & vbCrLf
            sMsg = sMsg & "SUBJECT: " & psSubject & vbCrLf & vbCrLf
            
            sMsg = sMsg & psMessage & vbCrLf & "." & vbCrLf
            .SendData sMsg
            
            WaitUntilTrue gbRequestAccepted, 45
             If pbExitImmediately Then Exit Sub
            If Not gbRequestAccepted Then
                TimeOut
                Exit Sub
            End If
                
            'If gbRequestAccepted Then RaiseEvent SendSuccesful
            .Close
         

End With
End If






End Sub
Friend Sub SendFail()
Dim iCount As Integer, iCtr As Integer
Dim sErrorString As String
Dim v As Variant
pbExitImmediately = True


With frmSckHost.sckMail

If Not .State = sckClosed Then
    frmSckHost.sckMail.Close
    Do Until frmSckHost.sckMail.State = sckClosed
        DoEvents
    Loop
End If
End With

End Sub


Private Sub Class_Terminate()
On Error Resume Next
If frmSckHost.sckMail.State = sckClosed Then
    frmSckHost.sckMail.Close
End If


    
End Sub

Public Function IsValidEmailAddress(AddressString As String)

Dim sHost As String
Dim iPos As Integer

If Len(Trim(AddressString)) = 0 Then
    IsValidEmailAddress = False
    Exit Function
End If


iPos = InStr(AddressString, "@")




If iPos = 0 Or Left(AddressString, 1) = "@" Then
    IsValidEmailAddress = False
    Exit Function
End If

sHost = Mid(AddressString, iPos + 1)
'can't have multiple "@" chars in the string
If InStr(sHost, "@") > 0 Then
    IsValidEmailAddress = False
    Exit Function
End If

IsValidEmailAddress = IsValidIPHost(sHost)


End Function

Private Sub TimeOut()

    SendFail
End Sub
Private Sub WaitUntilTrue(Flag As Boolean, TimeToWait As Long)
'PURPOSE:  Wait until either
'a condition is true or a timeout occurs

'The condition is specified by the value of
'flag passed by reference

'The TimeOut value is set by the
'timetowait parameter


Dim lStart As Long
Dim bPastMidnight As Boolean
Dim lTimetoQuit As Long


    lStart = CLng(Timer)
    'Deal with timeout being reset at Midnight
    If TimeToWait > 0 Then
        If lStart + TimeToWait < 86400 Then
            lTimetoQuit = lStart + TimeToWait
        Else
            lTimetoQuit = (lStart - 86400) + TimeToWait
            bPastMidnight = True
        End If
    End If

    Do Until Flag = True Or Timer >= lTimetoQuit
        DoEvents
        If pbExitImmediately Then Exit Sub
    Loop
   
End Sub

